



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Loadrunder脚本篇——关联数组（参数数组）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Loadrunder脚本篇——关联数组（参数数组）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 21:09:11 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>导言</h3>
<p>　　前面说过可以用关联取出服务器相关的一些动态变化的信息，前面也提过web_reg_save_param中可以设置ord=all，代表从服务器中取出的是一个数组，它试用的场景是当我访问一个发帖网站，有很多帖子，我们通过关联数组的方式获得本页所有帖子的id的一个数组，然后通过一个lr_paramarr_random函数随机取出这个数组的一个值，就模拟用户随机点击一个帖子，然后再把这个随机获取的值传到点击某一个帖子跳转页面的那个url里面，这样就完成了模拟用户随机点击帖子然后跳转到具体的帖子详情页，本篇将详细讲解通过脚本实现这个问题！</p>
<h3>1.从服务器获取的关联数组</h3>
<p>只要在关联函数中加入&ldquo;ord=all&rdquo;代表着取满足条件下的所有数据组成的数组。举例如下：</p>
<p>Action()<br />{<br />		web_reg_save_param("id",<br />		"LB=\"_id\":\"",<br />		"RB=\"",<br />		"Ord=ALL",<br />		LAST);</p>
<p>web_custom_request("web_custom_request",<br />		"URL=http://192.168.1.126:3000/apixxxxxxx",<br />		"Method=GET",<br />		"TargetFrame=",<br />		"Resource=0",<br />		"Referer=",<br />		"Body=",<br />		LAST);</p>
<p>return 0;<br />}</p>
<p>运行结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1226393/201801/1226393-20180125165120740-1036332432.png" /></p>
<p>从上面的结果看到，我们命名的为id不是一个数组了，是一个数组，他满足以下两个条件：</p>
<p>1.参数必须都是以相同的名字开头，后面接下划线加数字的方式顺序赋值。</p>
<p>2.参数数组必须有一个&ldquo;参数名_count&rdquo;的参数来记录数组的长度</p>
<p>相关函数：</p>
<p>lr_paramarr_idx()&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//获取参数数组中指定编号的参数的值</p>
<p>lr_paramarr_len()&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//获取参数数组的长度</p>
<p>lr_paramarr_random()&nbsp;&nbsp;//从参数列表中随机获取一个参数</p>
<h3>2.将内容保存为参数数组</h3>
<p>例子：要创建一个访问网站的参数数组，可以编写以下代码</p>
<p><img referrerpolicy="no-referrer"src="http://sucimg.itc.cn/sblog/o62caeeb5fcee9e2173caa71e7070d351" /></p>
<p>说明：通过脚本创建了一个名为website的参数数组，并获取编号为2的参数的值，</p>
<p>运行结果：</p>
<p><img referrerpolicy="no-referrer"src="http://sucimg.itc.cn/sblog/o58fffa8eb83477d7eee43c10901edc51" /></p>
<p>此处：web_site = lr_paramarr_idx("website", 2)，等同：lr_eval_string(&ldquo;{website_2}&rdquo;);</p>
<p>获取参数数组长度</p>
<p>例子：</p>
<p>Action2()</p>
<p>{</p>
<p>int array_size = 0;</p>
<p>char *arr_size_str = NULL;</p>
<p>lr_save_string("www.google.com", "website_1");</p>
<p>lr_save_string("www.google.com", "website_2");</p>
<p>lr_save_string("www.google.com", "website_3");</p>
<p>lr_save_string("www.google.com", "website_4");</p>
<p>lr_save_string("4", "website_count");</p>
<p>array_size = lr_paramarr_len("website");</p>
<p>//输出整数</p>
<p>//1.把结果array_size保存为参数</p>
<p>lr_save_int(array_size, "arr_size");</p>
<p>//2.获取参数的字符串表示</p>
<p>arr_size_str = lr_eval_string("{arr_size}");</p>
<p>//输出结果</p>
<p>lr_output_message(arr_size_str);</p>
<p>return 0;</p>
<p>}</p>
<p>运行结果：</p>
<p><img referrerpolicy="no-referrer"src="http://sucimg.itc.cn/sblog/o0554fadc9cc451f44c690dc15c19aa02" /></p>
<p>从参数列表中随机获取一个参数</p>
<p>例子：</p>
<p>Action2()</p>
<p>{</p>
<p>char *web_site = NULL;</p>
<p>lr_save_string("www.google.com", "website_1");</p>
<p>lr_save_string("www.google.com", "website_2");</p>
<p>lr_save_string("www.google.com", "website_3");</p>
<p>lr_save_string("www.google.com", "website_4");</p>
<p>lr_save_string("4", "website_count");</p>
<p>web_site = lr_paramarr_random("website");</p>
<p>return 0;</p>
<p>}</p>
<p>运行结果：</p>
<p><img referrerpolicy="no-referrer"src="http://sucimg.itc.cn/sblog/o1459e75f6e4171c5007b20ab39b91a8d" /></p>
<p>例子：按顺序输出每个参数</p>
<p>Action2()</p>
<p>{</p>
<p>int i = 0;</p>
<p>lr_save_string("www.google.com", "website_1");</p>
<p>lr_save_string("www.google.com", "website_2");</p>
<p>lr_save_string("www.google.com", "website_3");</p>
<p>lr_save_string("www.google.com", "website_4");</p>
<p>lr_save_string("4", "website_count");</p>
<p>for (i=0; i&lt;4;i++)</p>
<p>{</p>
<p>lr_output_message(lr_paramarr_idx("website", i));</p>
<p>}</p>
<p>return 0;</p>
<p>}</p>
<p>输出结果</p>
<p><img referrerpolicy="no-referrer"src="http://sucimg.itc.cn/sblog/oe7a6076517b2dca9842e8c0250dbb911" /></p>
<p><strong>&nbsp;</strong></p>
<p><strong>用指针变量存放参数</strong></p>
<p>Action2()</p>
<p>{</p>
<p>char *pt = NULL;</p>
<p>lr_save_string("hello world", "param");</p>
<p>pt = "{param}";</p>
<p>lr_output_message(pt);</p>
<p>lr_output_message(lr_eval_string(pt));</p>
<p>return 0;</p>
<p>}</p>
<p>运行结果：</p>
<p><img referrerpolicy="no-referrer"src="http://sucimg.itc.cn/sblog/o9588cffbd2ddd6189d5bb1bd49383c7e" /></p>
<h3>3.实战中的运用</h3>
<p>举例：</p>
<p>Action()<br />{<br />web_reg_save_param("id",<br />"LB=\"_id\":\"",<br />"RB=\"",<br />"Ord=ALL",<br />LAST);</p>
<p>web_custom_request("web_custom_request",<br />"URL=http://192.168.1.126:3000/apixxxxxxx",<br />"Method=GET",<br />"TargetFrame=",<br />"Resource=0",<br />"Referer=",<br />"Body=",<br />LAST);</p>
<p>lr_save_string(lr_paramarr_random("id"),"RamId");</p>
<p>web_custom_request("web_custom_request",<br />		"URL=http://1xxxxxxx/detail?_id={RamId} ",<br />		"Method=GET",<br />		"TargetFrame=",<br />		"Resource=0",<br />		"Referer=",<br />		"Body=",<br />		LAST);</p>
<p>return 0;<br />}</p>
<p>运行结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1226393/201801/1226393-20180125171918881-1830441007.png" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49gd0279.html">ssh 密码登陆</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyjn2gq.html">C&plus;&plus; 中的形参与返回值</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyde7wgq.html">NSLog 输出文件名、方法名、行号</a>
		</li>
						<li><a href="https://www.batexi.com/a/96poxdj8.html">Struts2 开发环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zonjj9.html">C&num;验证IP地址</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljnvke9.html">Memcached源码分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zojmjdq.html">Android -- Annotation（注解）原理详解及常见框架应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pll238.html">201521123091 《Java程序设计》第3周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgk2km8.html">bzoj1015星球大战</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzwwwg8.html">nuxt axios代理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjmpz69.html">iOS NSDictionary JSON 相互转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnwkl3q.html">这几天bug多，自我检讨一下</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1v6x69.html">谈谈hadoop集群启动时进程那回事</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7e02eg9.html">年薪30W的软件测试&OpenCurlyDoubleQuote;老司机&rdquo;工作经验</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p5e5eq.html">点击TextView 弹出复制选项</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mj46yo8.html">获取lambda表达式类型，获取attributes是注意事项</a>
		</li>
						<li><a href="https://www.batexi.com/a/953kvd68.html">spring mvc请求参数中文乱码解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/8odglxxq.html">给JSP应用提供JSTL支持（IntelliJ IDEA）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qndxm1g8.html">install ironic-inspector</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e545jj8.html">mongodb主从配置信息查看与确认</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qd5300j9.html">java过滤四字节和六字节特殊字符</a>
			</li>
						<li><a href="https://www.batexi.com/a/8odwnneq.html">HTTP协议之http状态码详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2xndrx9.html">JAVA自定义注解 ------ Annotation</a>
			</li>
						<li><a href="https://www.batexi.com/a/95pvx4eq.html">个人博客开发之xadmin与ueditor集成</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy2l12j9.html">Spring帖子汇总</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2xn5eo9.html">012android初级篇之Handler机制</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2xn5zo9.html">我买网B轮融资成功，五周年豪掷千万回馈会员</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jerm348.html">CMake error&colon;System Error&colon;No such file or directory  CMake error&colon;Could not open file for write in copy operation xxxx&period;ros&lowbar;Config&period;cmake&period;tmp&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8odwvlxq.html">YII配置rabbitMQ时前期工作各种坑</a>
			</li>
						<li><a href="https://www.batexi.com/a/q15njyz9.html">boost&colon;&colon;lockfree&colon;&colon;spsc&lowbar;queue</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
